function movie_matrix = ex5e_gqr_movie(sol_store,t_store,x)
% function movie_matrix = ex5e_gqr_movie(sol_store,t_store,x)
% Plays a movie made up of solutions at time steps t_store
% These values should be generated by the ex5e_gqr solvers
% Inputs : sol_store - solutions at frames of the movie
%          t_store - times for the movie
%          x - location of the points in the domain
% Outputs : movie_matrix - matrix full of frames

N = sqrt(size(x,1));

X = reshape(x(:,1),N,N);
Y = reshape(x(:,2),N,N);

% window_size = [122 204 971 504];
% movie_figure = figure('Position',window_size);
% 
% numframes = length(sol_store);
% movie_matrix = moviein(numframes,movie_figure,window_size);
% set(movie_figure,'NextPlot','replacechildren')
% for k=1:numframes
%     u = sol_store{k};
%     A = reshape(u(1:N*N),N,N);
%     H = reshape(u(1+N*N:end),N,N);
% 
%     subplot(1,2,1)
%     surf(X,Y,A,'EdgeColor','none') ,title(sprintf('Activator, t=%g',t_store(k)))
%     shading interp
%     zlim([0,.1]),grid off,xlabel('x'),ylabel('y'),axis square
%     subplot(1,2,2)
%     surf(X,Y,H,'EdgeColor','none'),title(sprintf('Inhibitor, t=%g',t_store(k)))
%     shading interp
%     zlim([0,.1]),grid off,xlabel('x'),ylabel('y'),axis square
%     cmap = colormap('jet');colormap(flipud(cmap))
%     pause(.1)
%     movie_matrix(:,k) = getframe(movie_figure,window_size);
%     movie_matrix(:,k) = getframe(movie_figure);
% end

numframes = length(sol_store);
u = sol_store{1};
H = reshape(u(1+N*N:end),N,N);
% movie_matrix = zeros(N*N,numframes);

% figure_handle = surf(X,Y,H);
figure_handle = surf(X,Y,H,'EdgeColor','none');
title(sprintf('Inhibitor, t=%g',t_store(1)))
shading interp
zlim([0,.1]),grid off,xlabel('x'),ylabel('y'),axis square

for k=1:numframes
    u = sol_store{k};
    H = reshape(u(1+N*N:end),N,N);
    set(figure_handle,'XData',X,'YData',Y,'ZData',H)
    title(sprintf('Inhibitor, t=%g',t_store(k)))
%     movie_matrix(:,k) = getframe;
    movie_matrix(k) = getframe;
end

% movie2avi(movie_matrix,'smallmovie.avi','compression','Cinepak')